from PyQt5 import QtWidgets
from PyQt5 import QtCore

import random
import os

words_dict = {
    "사자" : "lion",
    "호랑이" : "tiger",
    "사과" : "apple",
    "비행기" : "airplane"
}
words = []
for word in words_dict:
    words.append(word)
print(words)

class MyWindow(QtWidgets.QWidget):
    def __init__(self):
        super().__init__()
        global current_index, k
        current_index = 0
        k = 0

        ######################################################
        # 2. 윈도우 폼 구성하기
        ######################################################
        self.setWindowTitle("파이썬 GUI영어단어맞추기게임")

        self.lb_info1 = QtWidgets.QLabel("다음 한글을 영어로 입력하세요.", self)
        self.lb_info1.setAlignment(QtCore.Qt.AlignLeft)
        self.lb_info1.setStyleSheet("font-family:맑은 고딕;color:gray; font-size:16px;")

        self.lb_quiz = QtWidgets.QLabel("현재 퀴즈 부분 입니다.", self)
        self.lb_quiz.setAlignment(QtCore.Qt.AlignLeft)
        self.lb_quiz.setStyleSheet("font-family:맑은 고딕;color:blue; font-size:20px;")

        self.lb_info2 = QtWidgets.QLabel("총 문제수: 0개<br>맞춘개수: 0개<br>최종점수: 00점", self)
        self.lb_info2.setAlignment(QtCore.Qt.AlignCenter)
        self.lb_info2.setStyleSheet("font-family:맑은 고딕;color:red; font-size:20px;")

        self.input = QtWidgets.QLineEdit(self)
        self.input.setFixedHeight(30)
        self.input.setStyleSheet("font-family:맑은 고딕;color:black; font-size:20px;")

        layout = QtWidgets.QVBoxLayout()
        layout.addWidget(self.lb_info1)
        layout.addWidget(self.lb_quiz)
        layout.addWidget(self.lb_info2)
        layout.addWidget(self.input)
        self.resize(650, 200)
        self.setLayout(layout)


        ######################################################
        # 3. enter_key 함수 호출 및 정의
        ######################################################
        self.input.returnPressed.connect(self.enter_key)



        ######################################################
        # 7. 최초 게임 시작 시 동일한 문제가 출제되지 않고 시작시 마다
        # 다르게 출제하게 하기 위해서 초기화(섞어주고)하고, 
        ######################################################
        self.init_quiz()
        self.next_word()
       

        self.show()


    ######################################################
    # 3. enter_key 함수 호출 및 정의
    ######################################################
    def enter_key(self):
        global current_index, k

        if current_index < len(words):
            q = words[current_index]
            print(q, current_index)
        else:
            current_index = 0
            q = words[current_index]
        
        user_input = self.input.text()

        dictionary = words_dict[q]

        if user_input == dictionary:

            k = k + 1
            print("정답입니다.")
            self.lb_info2.setText("정답입니다. <br>현재까지 맞춘개수는 '"+str(k)+"'개 입니다.")
            self.input.setText("")
            current_index = current_index + 1

        else:
            print("틀렸습니다.")
            self.lb_info2.setText("틀렸습니다. <br>현재까지 맞춘개수는 '"+str(k)+"'개 입니다.")
            current_index = current_index + 1
            self.input.setText("")


        
        ######################################################
        # 4. 다음 문제 출제 함수 호출 및 실행
        ######################################################
        self.next_word()


    ######################################################
    # 5. 게임 초기화 함수 호출 및 실행
    ######################################################
    def init_quiz(self):
        global k
        random.shuffle(words)
        print(words)
        self.current_index = 0
        k = 0



    ######################################################
    # 4. 다음 문제 출제 함수 호출 및 실행
    ######################################################
    def next_word(self):
        global next_question
        if self.current_index < len(words):
            question = words[self.current_index]
            question = str(self.current_index+1)+". "+question
            if self.current_index + 1 < len(words):
                next_question = words[self.current_index + 1]
            else:
                pass

            self.lb_quiz.setText(question)
            self.current_index = self.current_index + 1
        else:
            self.lb_info2.setText("총 문제수: "+str(self.current_index)+"개<br>맞춘 개수: "+str(k)+"개<br>점수: "+str(k/self.current_index * 100)+"점")
            reply = QtWidgets.QMessageBox.question(self, 'GUI영어단어맞추기게임', '모든 문제를 출제했습니다.\n다시 하시겠습니까?',
                    QtWidgets.QMessageBox.Yes | QtWidgets.QMessageBox.No, QtWidgets.QMessageBox.Yes)
            if reply == QtWidgets.QMessageBox.Yes:

                ######################################################
                # 5. 게임 초기화 함수 호출 및 실행
                ######################################################
                self.init_quiz()
                self.next_word()
                self.lb_info2.setText("")
            else:
                exit(0)

######################################################
# 1. 윈도우 창 띄우기
######################################################
if __name__ == "__main__":
    app = QtWidgets.QApplication([])
    win = MyWindow()
    app.exec_()